import { Store } from '../store';
import { PersistPaths } from './persistPaths';
import { StorePersistStorage } from './persistStorage';
export declare class StorePersist<T> {
    readonly store: Store<T>;
    readonly storage: StorePersistStorage;
    readonly options: {
        paths?: (PersistPaths<T> | {
            path: PersistPaths<T>;
            throttleMs?: number;
        })[];
        throttleMs?: number;
    };
    initialization: Promise<void>;
    private isStopped;
    private sub?;
    private saveQueue;
    private isSaving;
    private saveTimeout?;
    private paths;
    constructor(store: Store<T>, storage: StorePersistStorage, options?: {
        paths?: (PersistPaths<T> | {
            path: PersistPaths<T>;
            throttleMs?: number;
        })[];
        throttleMs?: number;
    });
    private load;
    private watch;
    private addToSaveQueue;
    private run;
    private save;
    stop(): void;
}
